# RRI

## Dependencies

- gcc
- qt4
- R
- cmake

## Related tools

- [folding tool](https://github.com/bsc-performance-tools/folding). Requires at least version 1.2.1.

## Get the sources

    $ git clone --recursive https://github.com/bsc-performance-tools/rri.git

## Go into the directory

    $ cd rri

##Generate makefile##

    $ mkdir build
    $ cd build
    $ cmake ..

You may want to install rri in a custom location:

    $ cmake -DCMAKE_INSTALL_PREFIX=/your/installation/directory/ ..

## Compile

    $ make

## Install

    $ make install

## Install R libraries

Missing R libraries can be automatically installed using:

    # sudo make installR


## Apply RRI on a folding directory

    $ rri <folding-directory>

The output is generated by default in `<folding-directory>.rri`.

## Apply RRI on a callerdata file (command line program)

    $ rri -i <folding-directory>/<callerdata.file>

The output is generated by default in `<folding-directory>.rri`.

## Options:

      - -i --inputfile <file>: apply the process on a single callerdata file
      - -h --help: print usage
      - -o --output <directory>: output directory (rri by default)
      - -ts --timeslices [integer]: timeslice number used to discretize the time period (200 by default)
      - -th --threshold [float]: minimal distance between two parameters p (0.0001 by default)
      - -mp --minprop [float]: routine minimal proportion (0.8 by default)
      - -r --region [string]: apply rri on a single region; can be used several times to involve several regions

## Generate graphs from RRI data

    $ rri-visualize <rri-directory>

## Options:

      - -h --help: Print help
      - -c --clean: Remove all the generated pdf
      - -s --size [w] [h]: Set pdf outputs width and height in inch (default: 12 6)
      - -d --dpi [n]: Set pdf outputs dpi (default: 300)
      - -t --threads [n]: Enable multithreading using n threads 

## Generate profiling files

    $ rri-profiling <rri-directory>

## Options:

      - -h --help: Print help
      - -c --clean: Remove all the generated files
      - -d --dpi [n]: Set pdf outputs dpi (default: 300)
      - -f --functions [n]: Limit the number of printed functions in the pdf files to the n functions with the longest duration

